<template>
  <div class="single-choice-selector">
    <p class="single-choice-selector__selector-label">{{ label }}</p>
    <q-field
      filled
      item-aligned
      bg-color="secondary"
      class="cursor-pointer"
      bottom-slots
      :disable="isFetching"
    >
      <template v-slot:default>
        <div class="full-width row justify-left items-center">
          {{ normalizeNames(modelValue, normilizeNameOption() )}}
        </div>

        <q-menu
          @before-show="popupStateToggle(true)"
          @before-hide="popupStateToggle(false)"
          @hide="updateModelValue()"
          fit
          anchor="bottom right"
          self="top right"
          max-height='50vh'
          :disable="isFetching"
        >
          <div class="q-pa-md">
            <q-option-group
              v-model="UIdataModel"
              :options="options"
              :disable="isFetching"
              type="radio"
              size="lg"
            />
          </div>
        </q-menu>

      </template>

      <template v-slot:append>
        <q-icon
          name="expand_more"
          size="5vh"
          color="primary"
          class="cursor-pointer transition-expand"
          :class="isPopupShow ? 'rotate' : ''"
        />
      </template>

    </q-field>
  </div>
</template>

<script setup>
import { ref, computed, watchEffect } from 'vue';
import { contractingProcedures, processFasesOptions } from 'src/data/common-constants';
import normalizeNames from 'src/composables/get_normalized_name';

const props = defineProps({
  modelValue:     { type: String, required: true },
  indicatorType:  { type: String, required: true },
  isFetching:     { type: Boolean, required: true },
});

const emit = defineEmits(['update:modelValue']);

const localModel = computed({
  get: () => props?.modelValue,
  set: () => updateModelValue()
});

let UIdataModel;

const updateModelValue = () => {
  emit("update:modelValue", UIdataModel.value)
};

const label = computed(() => props.indicatorType === 'indicator_1_2' ? 'Fase del proceso' : 'Procedimiento de contratación');
const options = computed(() => props.indicatorType === 'indicator_1_2' ? processFasesOptions : contractingProcedures);

const normilizeNameOption = () => props.indicatorType === 'indicator_1_2' ? 'process_fase' : 'contracting_procedure';

const isPopupShow = ref(false);
const popupStateToggle = (state) => isPopupShow.value = state;

watchEffect(() => {
  UIdataModel = ref(localModel.value);
});

</script>

<style lang="scss">
@use './single-choice-selector-component-stylesheet.scss';
</style>